package jp.ac.kagawa_u.eng.wappen;

import javax.jnlp.ServiceManager;
import javax.jnlp.SingleInstanceService;

import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.ILog;
import org.eclipse.core.runtime.IPlatformRunnable;
import org.eclipse.core.runtime.Status;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.PlatformUI;


/**
 * This class controls all aspects of the application's execution
 */
public class Application implements IPlatformRunnable {

//static String[] args;
  /* (non-Javadoc)
   * @see org.eclipse.core.runtime.IPlatformRunnable#run(java.lang.Object)
   */
  public Object run(Object args) throws Exception {
//  Application.args = (String [])args;
//    if (1==1) throw new Exception("run");
    SingleInstanceService sis;
    SISListener sisL;

    try { 
      sis = 
        (SingleInstanceService)ServiceManager.lookup("javax.jnlp.SingleInstanceService");
      sisL = new SISListener();
      sis.addSingleInstanceListener(sisL);
    } catch (Exception e) { 
      sis=null; 
      sisL=null;
      ILog ilog = ResourcesPlugin.getPlugin().getLog();
      ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, Status.OK, "failed to add single instance listener", e));
    }

    Display display = PlatformUI.createDisplay();
    try {
      int returnCode = PlatformUI.createAndRunWorkbench(display, new ApplicationWorkbenchAdvisor());
      if (returnCode == PlatformUI.RETURN_RESTART) {
        return IPlatformRunnable.EXIT_RESTART;
      }
      return IPlatformRunnable.EXIT_OK;
    } finally {
      display.dispose();
      if(sis!=null) {
        sis.removeSingleInstanceListener(sisL);
        ILog ilog = ResourcesPlugin.getPlugin().getLog();
        ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, "removed single instance listener"));
      }
    }

  }

}
