package jp.ac.kagawa_u.eng.wappen;

import java.util.ArrayList;
import java.util.Properties;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.internal.adaptor.EclipseEnvironmentInfo;
import org.eclipse.swt.graphics.Point;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;

public class ApplicationWorkbenchWindowAdvisor extends WorkbenchWindowAdvisor {

    public ApplicationWorkbenchWindowAdvisor(IWorkbenchWindowConfigurer configurer) {
        super(configurer);
    }

    public ActionBarAdvisor createActionBarAdvisor(IActionBarConfigurer configurer) {
        return new ApplicationActionBarAdvisor(configurer);
    }
    
    public void preWindowOpen() {
        IWorkbenchWindowConfigurer configurer = getWindowConfigurer();
        configurer.setInitialSize(new Point(960, 720));
        configurer.setShowCoolBar(true);
        configurer.setShowMenuBar(true);
        configurer.setShowStatusLine(false);
        configurer.setTitle("Wappen RCP");

    }
    
    @Override
    public void postWindowOpen() {
      super.postWindowOpen();
      String[] args0 = EclipseEnvironmentInfo.getDefault().getNonFrameworkArgs();

      ArrayList<String> args = new ArrayList<String>();
      for (String a : args0) {
    	  args.add(a);
      }
      
      Properties props = System.getProperties();
      for (Object k : props.keySet()) {
        String key = (String)k;
        if (key.startsWith("wappen.")) {
          String p = props.getProperty(key);
          if (p!=null) {
            args.add("-"+key);
            args.add(p);
          }
        }     
      }
      
      SISListener.newActivationStatic(args.toArray(new String[]{}));
      
      IWorkbenchPage page =
    	  PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
      page.hideActionSet("org.eclipse.ui.edit.text.actionSet.annotationNavigation");
      page.hideActionSet("org.eclipse.ui.edit.text.actionSet.navigation");
      page.hideActionSet("org.eclipse.ui.edit.text.actionSet.convertLineDelimitersTo");
      page.hideActionSet("org.eclipse.ui.actionSet.openFiles");
    }

    @Override
    public void postWindowClose() {
      super.postWindowClose();
      // ׂĂ̐t@CB
      for(IProject p : SISListener.openedProjects) {
        try {
          p.delete(true, null);
        } catch (CoreException e) {}
      }
      // WorkspaceɁiƂjL^B
      try {
        ResourcesPlugin.getWorkspace().save(true, null);
      } catch (CoreException e) {}
    }
}
