package jp.ac.kagawa_u.eng.wappen;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Scanner;

import javax.jnlp.BasicService;
import javax.jnlp.ServiceManager;
import javax.jnlp.SingleInstanceListener;
import javax.jnlp.UnavailableServiceException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.ILog;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.QualifiedName;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.content.IContentType;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.IEditorDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorRegistry;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.FileInPlaceEditorInput;

public class SISListener implements SingleInstanceListener {

	final public static ArrayList<IProject> openedProjects = new ArrayList<IProject>();

	public void newActivation(final String[] params) {
		PlatformUI.getWorkbench().getDisplay().asyncExec(new Runnable() {
			public void run() {
				newActivationStatic(params);
			}
		});
	}

	private static HashMap<String, String> processArgs(String[] args) {
		HashMap<String, String> ret = new HashMap<String, String>();
		int i=0;
		while(i<args.length) {
			String arg = args[i];
			if (arg.startsWith("-wappen.")) {
				String key = arg.substring(1);
				String val = args[i+1];
				ret.put(key, val);
				i+=2;
			} else {
				// skip 
				i++;
			}
		}
		return ret;
	}

	public static void newActivationStatic(String[] args0) {
//		org.eclipse.core.runtime.adaptor.EclipseStarter.run(params);
		String logmsg = "";
		ILog ilog = ResourcesPlugin.getPlugin().getLog();
//		for (String p : args0) {
//		logmsg += "\"";
//		logmsg += p;
//		logmsg += "\", ";
//		}
//		ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, Status.OK, "newActivationStatic invoked with "+logmsg, null));
//		logmsg = "";

		String[] args = args0;
		URL baseURL=null, srcURL=null, uploadURL=null;
		String cookies, natures; 
		String[] jars, hiddens;
//		String message;
		if(args==null) {
//			logmsg += String.format("// ܂B%d%n", args==null ? -1 : args.length);
//			MessageDialog.openInformation(
//			null,
//			"Information",
//			String.format("܂B%d%n", params.length)
//			);
		} else {  
			for(int i=0; i<args.length; i++) {
				logmsg += String.format("args[%d]=%s, ", i, args[i]);
			}
			logmsg += String.format("%n");
//			MessageDialog.openInformation(
//			null,
//			"Information",
//			String.format("args[0]=%s, args[1]=%s, args[2]=%s", params[0], params[1], params[2])
//			);
		}

		try {
			BasicService bs = (BasicService)ServiceManager.lookup("javax.jnlp.BasicService");
			baseURL  = bs.getCodeBase();
		} catch (UnavailableServiceException e) {
			baseURL = null;
//			logmsg += String.format("UnavailabeService: baseURL = null%n");
//			ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, Status.OK, "newActivationStatic messages:"+logmsg, e));
//			logmsg = "";
		}

		HashMap<String,String> hm = processArgs(args); 
		if(hm.containsKey("wappen.baseURL")) {
			String tmp = hm.get("wappen.baseURL");
			if (tmp!=null) {
				try {
					baseURL = new URL(baseURL, tmp);
				} catch (MalformedURLException e) {
					try { 
						// try to interpret wappen.baseURL as a file path for testing
						baseURL = new File(tmp).toURI().toURL();
					} catch (Exception e1) {
						MessageDialog.openInformation(null,
								"", //$NON-NLS-1$
						String.format("Property wappen.baseURLݒ肳Ă܂ (%s)B", tmp)); 
						return;
					}
				}
			}
		}

		String[] sources = null;
		sources = mySplit(hm.get("wappen.sources"));
		if (sources.length==0) {
			MessageDialog.openInformation(null, "", //$NON-NLS-1$
			                              "Property wappen.sourcesݒ肳Ă܂B"); 
		}

		jars = mySplit(hm.get("wappen.jars"));
		hiddens = mySplit(hm.get("wappen.hiddens"));
		String upload = hm.get("wappen.upload");
		if (upload!=null) {
			try {
				uploadURL  = new URL(baseURL, upload);
			} catch (MalformedURLException e) {}
		} else {
			
		}

		natures    = hm.get("wappen.natures");
		cookies    = hm.get("wappen.cookies");

		/*
      	Talk about luck.  I was actually trying to do this yesterday and put a question into a editor guru.  If you are using 3.3, you need to get the latest Platform UI plugins out of head.  Then you can use the following two lines of code to open an editor on a file outside the workspace.

      	EFS.getLocalFileSystem().getStore(yourPath);
      	IDE.openEditorOnFileStore(page, fileStore);

      	If you are using 3.2 or previous, try http://wiki.eclipse.org/index.php/FAQ_How_do_I_open_an_editor_on_a_file_outside_the_workspace%3F

      	Brian Bauman
          	IBM Software Group - Austin, TX
          	Eclipse Committer
		 */

		IWorkspace ws = ResourcesPlugin.getWorkspace();
		long time = System.currentTimeMillis();
		String projectName = String.format("Project%1$ty%1$tm%1$td%1$tH%1$tM%1$tS%1$tL", time);
		IProject project = ws.getRoot().getProject(projectName);
		
	
		try {
			if (!project.exists())
				project.create(null);
			if (!project.isOpen())
				project.open(null);
		} catch (CoreException e1) {} 
		openedProjects.add(project);
		
		String encoding = hm.get("wappen.encoding");
		if (encoding!=null&&encoding.trim().length()==0) {
			encoding=null;
		}
//		if (encoding!=null && encoding.trim().length() > 0) {	
//			IScopeContext projectScope = new ProjectScope(project);
//			Preferences encodingSettings = projectScope.getNode(ResourcesPlugin.PI_RESOURCES).node("encoding");
//				
//			if (encodingSettings!=null) {
//				encodingSettings.put("<project>", encoding);
//				try {
//					encodingSettings.flush();
//				} catch (BackingStoreException e) {
//					e.printStackTrace();
//				}
//			}
//		}

		// EclipsevOCJ@OU p.256
		try {
			project.setSessionProperty(new QualifiedName(null, "__baseURL"), baseURL);
			project.setSessionProperty(new QualifiedName(null, "__upload"), uploadURL);
			for(String key : hm.keySet()) {
				if (key.startsWith("wappen.")) {
					String value = hm.get(key);
					key = key.substring("wappen.".length());

					project.setSessionProperty(new QualifiedName(null, key), value);                   
				}  
			}
			
			ArrayList<IFile> jarfiles = new ArrayList<IFile>();
			String[] jarPaths = mySplit(hm.get("wappen.jarPaths"));
			for(int i=0; i<jars.length; i++) {
				String jar = jars[i];
				URL jarURL = new URL(baseURL, jar);	
				IFile jarfile; 
				try {
					jarfile = downloadFileAs(jarURL, cookies, project, jarPaths[i], null);
				} catch (ArrayIndexOutOfBoundsException e) {
					jarfile = downloadFile(jarURL, cookies, project, calcPathDifference(baseURL, jarURL), null);
				}
				if (jarfile!=null) {
					if (jarfile.exists()) {
						jarfiles.add(jarfile);
					} else {
						MessageDialog.openError(null, "error", "file: "+jarURL.toExternalForm()+" could not be downloaded.");
					}
				}
			}
			project.setSessionProperty(new QualifiedName(null, "__jars"), jarfiles);

			ArrayList<IFile> hiddenfiles = new ArrayList<IFile>();
			String[] hiddenPaths = mySplit(hm.get("wappen.hiddenPaths"));
			for(int i=0; i<hiddens.length; i++) {
				String hidden = hiddens[i];
				URL hiddenURL = new URL(baseURL, hidden);
				IFile hfile;
				try {
					hfile = downloadFileAs(hiddenURL, cookies, project, hiddenPaths[i], null);
				} catch (ArrayIndexOutOfBoundsException e) {
					hfile = downloadFile(hiddenURL, cookies, project, calcPathDifference(baseURL, hiddenURL), null);
				}
				if (hfile!=null) {
					if (hfile.exists()) {
						hiddenfiles.add(hfile);
					} else {
						MessageDialog.openError(null, "error", "file: "+hiddenURL.toExternalForm()+" could not be downloaded.");
					}
				}
			}

			project.setSessionProperty(new QualifiedName(null, "__hiddens"), hiddenfiles);
			
			ArrayList<URL> sourceURLs = new ArrayList<URL>();
			ArrayList<IFile> sourcefiles = new ArrayList<IFile>();
			String[] sourcePaths = mySplit(hm.get("wappen.sourcePaths"));
			for (int i=0; i<sources.length; i++) {
				String src = sources[i];
				srcURL = new URL(baseURL, src);
				sourceURLs.add(srcURL);
				IFile file;
				try {
					file = downloadFileAs(srcURL, cookies, project, sourcePaths[i], encoding);
				} catch (ArrayIndexOutOfBoundsException e) {
					file = downloadFile(srcURL, cookies, project, calcPathDifference(baseURL, srcURL), encoding);	
				}
				
				if (file!=null) {
					if (file.exists()) {
						sourcefiles.add(file);
						IEditorInput input = new FileInPlaceEditorInput(file);
						IWorkbench workbench = PlatformUI.getWorkbench();
						IWorkbenchWindow window = workbench.getActiveWorkbenchWindow(); 
						IWorkbenchPage page= window.getActivePage();
						String editorId = hm.get("wappen.editorId"); // editorIdIɌ߂邱ƂłB
						if (editorId==null) {        	
							IEditorRegistry editorRegistry= workbench.getEditorRegistry();
							IContentType contentType=null;
							contentType = Platform.getContentTypeManager().findContentTypeFor(file.getContents(), file.getName());

//							IEditorDescriptor descriptor= editorRegistry.getDefaultEditor(file.getName(), contentType);
//							IEditorDescriptor descriptor= editorRegistry.getDefaultEditor(file.getName());
//							String editorId = descriptor != null ? descriptor.getId() : "org.eclipse.ui.DefaultTextEditor";
//							logmsg += String.format("descriptor = %s, editorId=%s%n", descriptor, editorId);
							// TODO ƐIȕ@T
							IEditorDescriptor[] descriptors = editorRegistry.getEditors(file.getName(), contentType);
							editorId = descriptors.length > 0 ? descriptors[descriptors.length-1].getId() : "org.eclipse.ui.DefaultTextEditor";
							// 0Ԗڂ͏ DefaultTextEditor̂悤
//							logmsg += String.format("contentType=%s; editorId=%s%n", contentType.getId(), editorId);
//							logmsg += String.format("descriptor = %s, editorId=%s%n", descriptors[descriptors.length-1], editorId);
							ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, Status.OK, "newActivationStatic messages:"+logmsg, null));

//							editorId = "org.eclipse.jdt.ui.CompilationUnitEditor";
//							String editorId = "org.eclipse.ui.DefaultTextEditor";
//							editorId = "org.eclipse.ui.JavaEditor";
//							String editorId = Editor.EDITOR_ID;
						}
						page.openEditor(input, editorId);
					} else {
						MessageDialog.openError(null, "error", "file: "+srcURL.toExternalForm()+" could not be downloaded.");
					}
				}
			}

			project.setSessionProperty(new QualifiedName(null, "__sources"), sourcefiles);

			// downloadInatureݒ肷
			// TODO downloadI܂łő҂
			if (natures!=null && !natures.equals("")) {
				for (String nature : natures.split(" ")) {
					logmsg += String.format("nature %s%n", nature);
					ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, Status.OK, "newActivationStatic messages:"+logmsg, null));
					logmsg = "";
					addProjectNature(project, nature);
				}
			}
		} catch (Exception e) {
			logmsg += String.format("Exception%n%s%n", e.toString());
			ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, Status.OK, "newActivationStatic messages:"+logmsg, e));
			logmsg = "";
		}
	}

	private static void addProjectNature(IProject project, String nature) {
		try { 
			IProjectDescription description = project.getDescription();
			String[] natures = description.getNatureIds();
			boolean flag = true; 
			for(String s : natures) {
				if (s.equals(nature)) {
					flag = false;
				}
			}
			if (flag==true) {
				String[] newNatures = new String[natures.length + 1];
				System.arraycopy(natures, 0, newNatures, 0, natures.length);
				newNatures[natures.length] = nature;
				description.setNatureIds(newNatures);
				project.setDescription(description, null);
			}
		} catch (CoreException e) {
			String logmsg = "";
			ILog ilog = ResourcesPlugin.getPlugin().getLog();
			logmsg += String.format("CoreException %n%s%n", e.toString());
			ilog.log(new Status(Status.INFO, Activator.PLUGIN_ID, Status.OK, "newActivationStatic messages:"+logmsg, e));
			logmsg = "";
		}
	}

	private static String calcPathDifference(URL base, URL url) {
		if (base==null) return "";
		String basePath = base.toString();
		String path     = url.toString();
		if(!basePath.endsWith("/")) {
			basePath+="/";
		}
		if(path.startsWith(basePath)) {
			String diff = path.substring(basePath.length());
			return diff.substring(0, diff.lastIndexOf('/')+1);
		}
		return "";  
	}

	private static String getFilenameFromConnection(URLConnection conn) {
		String field = conn.getHeaderField("Content-Disposition");
		if (field==null) return null;
		Scanner sc = new Scanner(field).useDelimiter("\\s*;\\s*");
		String attachment = sc.next();
		if (!attachment.equalsIgnoreCase("attachment")) return null;
		while(sc.hasNext()) {
			String next = sc.next();
			Scanner sc1 = new Scanner(next).useDelimiter("\\s*=\\s*");
			if(sc1.next().equalsIgnoreCase("filename")) {
				String value = sc1.next();
				return value.substring(value.indexOf('\"')+1, value.lastIndexOf('\"'));
			}
		}  
		return null;
	}

	private static void createFoldersRecursively(String prefix, final Iterator<String> folders, final IProject project, final IProgressMonitor monitor) {
		if (!folders.hasNext()) {
			monitor.done();
			return;
		}
		String s = folders.next();
		final String path = prefix+"/"+s;
		try {
			IFolder folder = project.getFolder(path);
			if (!folder.exists()) {
				folder.create(true, false, new NullProgressMonitor(){
					@Override
					public void done() {
						createFoldersRecursively(path, folders, project, monitor);
					}  
				});
			} else {
				createFoldersRecursively(path, folders, project, monitor);
			}
		} catch (CoreException e) {
			e.printStackTrace();
		}
		return;
	}
	

	private static void createFoldersAndFile(final IProject project, final URLConnection conn, final IFile file, Scanner scanner, String encoding) throws IOException {

		final InputStream is;
		if (encoding!=null && !Charset.forName(encoding).equals(Charset.defaultCharset())) {
			// don't mind -- source files are all short 
			BufferedReader r = new BufferedReader(new InputStreamReader(conn.getInputStream(), encoding));
			StringBuilder sb = new StringBuilder();
			String line;
			while((line=r.readLine())!=null) {
				sb.append(String.format("%s%n", line));
			}
			is = new ByteArrayInputStream(sb.toString().getBytes());		
		} else {
			is = conn.getInputStream();
		}
		createFoldersRecursively("", scanner, project, new NullProgressMonitor() {
			@Override
			public void done() {
				try {
					if (!file.exists()) {
						file.create(is, IFile.FORCE, null);
					} else {
						// TODO report an error
					}
				} catch (Exception e) {
					e.printStackTrace();
					try {
						file.delete(true, null);
					} catch (CoreException e1) {}
				}
			}
		});
	}

	private static IFile downloadFile(URL srcURL, String cookies, IProject project, String prefix, String encoding)  {
		final URLConnection conn;
		try {
			conn = srcURL.openConnection();
		} catch (IOException e1) {
			return null;
		}
		if (cookies!=null) {
			for(String cookie : cookies.split(" "))
				conn.addRequestProperty("cookie", cookie);
		}
		String path = srcURL.getPath();
		String filename = getFilenameFromConnection(conn);
		if(filename==null) {
			filename = path.substring(path.lastIndexOf('/')+1);
		}
		final IFile file = project.getFile(prefix+filename);
		Scanner scanner = new Scanner(prefix).useDelimiter("/");
		try {
			createFoldersAndFile(project, conn, file, scanner, encoding);
			return file;
		} catch (IOException e) {
			return null;
		}

	}

	
	private static IFile downloadFileAs(URL srcURL, String cookies,	IProject project, String path, String encoding) {
		final URLConnection conn;
		try {
			conn = srcURL.openConnection();
		} catch (IOException e1) {
			return null;
		}
		if (cookies!=null) {
			for(String cookie : cookies.split(" "))
				conn.addRequestProperty("cookie", cookie);
		}
		final IFile file = project.getFile(path);
		int idx = path.lastIndexOf('/');
		String prefix = idx==-1 ? "" : path.substring(0, idx);
		Scanner scanner = new Scanner(prefix).useDelimiter("/");
		try {
			createFoldersAndFile(project, conn, file, scanner, encoding);
			return file;
		} catch (IOException e) {
			return null;
		}
	}
	
	private static String[] mySplit(String xs) {
		if(xs==null) {
			return new String[0];
		} else {
			return xs.split("\\s+");
		}
	}
}