package jp.ac.kagawa_u.eng.wappen.util;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

import javax.jnlp.BasicService;
import javax.jnlp.ServiceManager;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.QualifiedName;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Shell;

public class Service {

  public static void openBrowser(String redirectURL) {
    try {
      BasicService bs = (BasicService)ServiceManager.lookup("javax.jnlp.BasicService");
      // Invoke the showDocument method
      bs.showDocument(new URL(redirectURL)); 
    } catch (Exception e) {
      Shell shell = new Shell();      
      shell.setText(redirectURL);
      shell.setSize(new Point(670,530));
      Browser browser = new Browser(shell, SWT.NONE);      
      browser.setBounds(10, 10, 640, 480);
      browser.setUrl(redirectURL);
      shell.open();
    }
  }

  public static void viewURL(String filename, URL url) {
	  try {
		  BasicService bs = (BasicService)ServiceManager.lookup("javax.jnlp.BasicService");
		  // Invoke the showDocument method
		  bs.showDocument(url); 
	  } catch (Exception e) {
		  Shell shell = new Shell();      
		  shell.setText("Preview - " + filename);
		  shell.setSize(new Point(670,530));
		  Browser browser = new Browser(shell, SWT.NONE);      
		  browser.setBounds(10, 10, 640, 480);
		  browser.setUrl(url.toString());
		  shell.open();
	  }
  }
  
	public static void genericPreview(IProject project) {
		String outpath;
		URL txtURL;

		try {
//			String path0 = "C:\\Users\\koji\\Desktop\\eXg\\test.html";
//			System.err.println(new File(path0).toURI().toURL());
			
			outpath = (String)(project.getSessionProperty(new QualifiedName(null, "startPage")));
//			outpath = "eXg/test.html";
			if (outpath==null) {
				outpath = (String)(project.getSessionProperty(new QualifiedName(null, "output")));
			}
			IFile outfile = project.getFile(outpath);
//			System.out.println(outfile.getLocationURI().toURL());
//			System.out.println(new File(outfile.getLocation().toOSString()).toURI().toURL());
			if (!outfile.exists()) {
				System.err.printf("File %s does not exist.", outfile.getLocation().toOSString());
				return;
			}

			txtURL = outfile.getLocationURI().toURL();
			// txtURL = new File(outpath).toURI().toURL();
	
		} catch (CoreException e) {
			e.printStackTrace(System.err);
			return;   
		} catch (MalformedURLException e) {
			e.printStackTrace(System.err);
			return;
		}

		viewURL(outpath, txtURL);
	}

	public static void genericSetEnabled(IProject project, IAction action, ISelection selection) {
		String outpath;
		try {
			outpath = (String)(project.getSessionProperty(new QualifiedName(null, "startPage")));

			if (outpath==null) {
				outpath = (String)(project.getSessionProperty(new QualifiedName(null, "output")));
			}

			action.setEnabled(outpath!=null);
		} catch (Exception e) {
			action.setEnabled(false);
		}
		
	}
}
